import random
from queue import PriorityQueue
import time


def idbfs(G, x, y, w):
    dist = [1 << 30 for _ in range(len(G))]
    dist[x] = 0
    queue = PriorityQueue()
    queue.put((dist[x], x))
    while not queue.empty():
        u = queue.get()[1]
        queue.task_done()
        if u == y:
            return dist[u]
        for t in G[u]:
            v = t[0]
            dv = t[1]
            if dv <= w:
                if (dist[u] % w) + dv <= w:
                    alt = dist[u] + dv
                    if alt < dist[v]:
                        dist[v] = alt
                        queue.put((alt, v))
                else:
                    alt = dist[u] + w - (dist[u] % w) + dv
                    if alt < dist[v]:
                        dist[v] = alt
                        queue.put((alt, v))
    return -1


def done(G, s, e, w):
    solvable = idbfs(G, s, e, w)
    if solvable == -1:
        return False
    else:
        return solvable != idbfs(G, s, e, 100)


def next_rand(nodes, paths, start, end, solution_weight, graph_weight=100):
    if start > nodes or end > nodes:
        return "start or end not in graph"
    graph = [[] for _ in range(nodes)]
    reset = False
    # add edges randomly
    while not done(graph, start, end, solution_weight):
        reset ^= True
        if reset:
            edges = 0
            graph = [[] for _ in range(nodes)]
        else:
            i = 0
            while i < edges // 10:
                index = random.randint(0, nodes - 1)
                if len(graph[index]) > 0:
                    i += 1
                    graph[index].pop()
        while edges < paths:
            orig = random.randint(0, nodes - 1)
            dest = random.randint(0, nodes - 1)
            if orig == dest:
                continue
            dist = random.randint(0, graph_weight - 1)
            if [dest, dist] not in graph[dest]:
                graph[orig].append([dest, dist])
                graph[dest].append([orig, dist])
                edges += 1
    return graph


n = 10000
e = 200000
s = 0
en = n - 1
w = 20

cabins = next_rand(n, e, s, en, w)

t0 = time.time()
tent = idbfs(cabins, s, en, 100)
cabin = idbfs(cabins, s, en, w)
timer = time.time() - t0

print(n, e, s, en, w)
for n_id, n in enumerate(cabins):
    for trails in n:
        cabins[trails[0]].remove([n_id, trails[1]])
        print(n_id, trails[0], trails[1])
print(cabin - tent)
print(tent, cabin, timer)
