#!/usr/bin/python3
#  x startpoint y endpoint
#  find out how much faster group one arrives format
#  n number of cabins
#  m number of trails between kabins
#  w time walking each day
#  format for graph [ n m x y w]
#  format for trail [ x y w ]

from queue import PriorityQueue
import math
numbers = [int(i) for i in input().split()]
graph = [list() for _ in range(numbers[0])]

for i in range(numbers[1]):
    trail = [int(x) for x in input().split()]
    graph[trail[0]].append([trail[1], trail[2]])
    graph[trail[1]].append([trail[0], trail[2]])


def dijkstra(G, x, y):
    dist = [1 << 30 for _ in range(len(G))]
    dist[x] = 0
    queue = PriorityQueue()
    queue.put((dist[x], x))
    while not queue.empty():
        u = queue.get()
        u = u[1]
        if u == y:
            return dist[u]
        for t in G[u]:
            v = t[0]
            alt = t[1] + dist[u]
            if alt < dist[v]:
                dist[v] = alt
                queue.put((alt, v))
    return -1


def idbfs(G, x, y, w):
    last_d = 0
    dist = [1 << 30 for _ in range(len(G))]
    dist[x] = 0
    queue = PriorityQueue()
    queue.put((dist[x], x))
    while not queue.empty():
        u = queue.get()[1]
        if u == y:
            return dist[u], last_d
        for t in G[u]:
            v = t[0]
            dv = t[1]
            if dv <= w:                     # only edges walkable in w time
                alt = -1
                if (dist[u] % w) + dv <= w: #this day
                    alt = dist[u] + dv
                else:                       #next day
                    alt = dist[u] + w - (dist[u] % w) + dv
                    #alt += 12
                if alt < dist[v]:
                    dist[v] = alt
                    last_d = dv
                    queue.put((alt, v))
    return -1, -1

tent_walk = dijkstra(graph, 0, numbers[0] - 1)
cabin_walk, l_d = idbfs(graph, 0, numbers[0] - 1, 12)


def trip_time(walked):
    return math.floor((walked / 12)) * 24 + walked % 12

#print(tent_walk, cabin_walk, l_d)

tent_walk = 12 *  ((tent_walk - 1 )  // 12 if tent_walk > 0 else 0) + tent_walk
cabin_walk = 12 * ((cabin_walk - 1) // 12 if cabin_walk > 0 else 0) + cabin_walk


days = cabin_walk - tent_walk
print(days)













