#!/usr/bin/env python2
from __future__ import print_function, division
from sys import stdin
from heapq import heappush as push
from heapq import heappop as pop

def nototents():
    n, m = [int(x) for x in stdin.readline().split()]
    graph = [[] for _ in range(n)]
    
    for _ in range(m):
        u, v, d = [int(x) for x in stdin.readline().split()]
        graph[u].append((v, d))
        graph[v].append((u, d))
        
    ## Begin with Dr. Olsen. Do normal dijkstra on distance, then
    ## calculate the time spent to do the trip afterwards.
    DAY = 12
    NIGHT = 24 - DAY
    INF = float('inf')
    tentDist = [INF]*n
    pq = [(0, 0)]
    while len(pq) > 0:
        d, u = pop(pq)
        if tentDist[u] <= d:
            continue
        tentDist[u] = d
        for nbr, linkd in graph[u]:
            if tentDist[nbr] == INF:
                push(pq, (d+linkd, nbr))
    
    walkTime = tentDist[-1]
    nightsOlsen = max(0, (walkTime-1) // DAY)
    travelTimeOlsen = nightsOlsen * (NIGHT) + walkTime
    
    ## Careful with above: be consisten with what happens at time 20:00 vs
    ## 08:00 the next day between Olsen and Larsen. We here use convention
    ## that 19:59 goes to 08:00
    
    ## Now, do Mr. Larsen. We do a dijkstra with time; for simplicity,
    ## we prentend that each day is 12 hours (we add sleep time later).
    ## Some time will be idle in a cabin; we convert that idle time to
    ## distance (he's walkin in circles around the cabin), so we can do
    ## the same math as with Dr. Olsen.
    INF = (INF, INF)
    cabinDist = [INF]*n
    pq = [((0, 0), 0)]
    while len(pq) > 0:
        (day, hour), u = pop(pq)
        if cabinDist[u] <= (day, hour):
            continue
        cabinDist[u] = (day, hour)
        for nbr, linkd in graph[u]:
            if cabinDist[nbr] == INF and linkd <= DAY:
                if linkd + hour <= DAY:
                    push(pq, ((day, linkd + hour), nbr))
                else:
                    push(pq, ((day + 1, linkd), nbr))
                    
    daysLarsen, walkTimeLastDay = cabinDist[-1]
    travelTimeLarsen = daysLarsen * (DAY + NIGHT) + walkTimeLastDay
        
    return travelTimeLarsen - travelTimeOlsen
        


print(nototents())