#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

constexpr int MAXN = 100;

struct vec {
    double v[MAXN];
};

struct matrix {
    double m[MAXN][MAXN];

    matrix operator*(const matrix &other) const {
        matrix res = matrix();
        for (int i = 0; i < MAXN; i++)
            for (int j = 0; j < MAXN; j++)
                for (int k = 0; k < MAXN; k++)
                    res.m[i][j] += m[i][k] * other.m[k][j];
        return res;
    }

    vec operator*(const vec &other) const {
        vec res = vec();
        for (int i = 0; i < MAXN; i++)
            for (int j = 0; j < MAXN; j++)
                res.v[j] += other.v[i] *  m[i][j];

        return res;
    }
};

int r, c, n;
double p;

int main() {
    cin >> r >> c >> n >> p;
    matrix dice;
    for (int i = 0; i < r*c; i++) {
        for (int j = i+1; j <= i+6; j++)
            dice.m[i][min(j, r*c-1)] += 1.0/6.0;
    }

    matrix ladder;
    for (int i = 0; i < r*c; i++)
        ladder.m[i][i] = 1;
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        ladder.m[a][a] = 0;
        ladder.m[a][b] = 1;
    }

    matrix mat = dice * ladder;

    vec res;
    res.v[0] = 1;
    int count = 0;

    while (res.v[r*c-1] < p) {
        res = mat * res;
        count++;
    }

    cout << count << endl;
}
