from __future__ import absolute_import, division, print_function
import re
import sys


def main():
    INTEGER_REGEX = "(?:0|[1-9][0-9]*)"
    FIRST_LINE_REGEX = " ".join([INTEGER_REGEX] * 4) + "\\n"
    line1 = sys.stdin.readline()
    assert re.match(FIRST_LINE_REGEX, line1)
    d, t, c, r = (int(x) for x in line1.split())
    assert 1 <= d <= 1000
    assert d <= t <= 10000
    assert 0 <= c <= 1000000
    assert 0 <= r <= d

    FLOAT_REGEX = "(?:0|[0-9]+[.][0-9]+)"
    RAIN_LINE_REGEX = " ".join([INTEGER_REGEX] * 2 + [FLOAT_REGEX, INTEGER_REGEX]) + "\\n"

    for _ in xrange(c):
        rain_line = sys.stdin.readline()
        assert re.match(RAIN_LINE_REGEX, rain_line)
        start, stop, prob, amount = rain_line.split()
        start = int(start)
        stop = int(stop)
        prob = float(prob)
        amount = int(amount)
        assert 0 <= start < t
        assert 1 <= stop < t + 1
        assert start < stop
        assert 0 <= prob <= 1
        assert 0 <= amount <= 100
    
    ROOF_REGEX = " ".join([INTEGER_REGEX] * 2) + "\\n"
    min_roof = 0
    max_roof = d

    for _ in xrange(r):
        roof_line = sys.stdin.readline()
        assert re.match(ROOF_REGEX, roof_line)
        start, stop = (int(x) for x in roof_line.split())
        assert start >= min_roof
        assert stop <= max_roof + 1
        min_roof = stop

    last_line = sys.stdin.readline()
    assert len(last_line) == 0
    sys.exit(42)


if __name__ == '__main__':
    main()
