#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

void printMatrix(vector<vector<float>> vvi, float max_rain) {
	for (auto v : vvi) {
		for (float i : v) 
			cout << i << "\t";	
		cout << endl;
	}
}

template <typename T>
void printVector(vector<T> v) {
	for (T t : v)
		cout << t << " ";
	cout << endl;
}

int main() {
	int rows, cols, clouds, roofs;
	cin >> rows >> cols >> clouds >> roofs;
	rows++;
	cols++;
	vector<vector<float>> vvi(rows, vector<float>(cols));
	vector<float> rain(cols);
	for (int i = 0; i < clouds; i++) {
		int s, e, a;
		float p;
		cin >> s >> e >> p >> a;
		float amount = p * (float)a;
		for_each(rain.begin() + s, rain.begin() + e, 
			[amount](float& r) { r += amount; });
	}
	vector<bool> roof(cols);
	roof[0] = true;
	for (int i = 0; i < roofs; i++)	{
		int s, e;
		cin >> s >> e;
		fill(roof.begin() + s, roof.begin() + e + 1, true);
	}
	for_each(vvi.begin() + 1, vvi.end(), [rain](vector<float> &v) {
		fill(v.begin(), v.end(), accumulate(rain.begin(), rain.end(), 1.0f)); 
	});
	auto cost = [rain, roof](int i, int j) {return roof[i] ? 0 : rain[j-1]; };
	auto move_cost = [rain, roof](int i, int j) {
		if (roof[i - 1] && roof[i])
			return 0.0f;
		return rain[j - 1];
	};
	float maximum = accumulate(rain.begin(), rain.end(), 1.0f);
	for (int i = 1; i < rows; i++) {
		for (int j = i; j < cols; j++) {
			float move = maximum;
			if (i + 1 < cols)
				move = move_cost(i, j) + vvi[i - 1][j - 1];
			float stay = cost(i, j) + vvi[i][j - 1];
			vvi[i][j] = min(move, stay);
		}
	} 
	/*
	cout << endl;
	printVector(rain);
	cout << endl;
	printVector(roof);
	cout << endl;
	printMatrix(vvi, accumulate(rain.begin(), rain.end(), 1.0f));
	cout << endl;
	*/
	cout << vvi.back().back() << endl;
}
