from __future__ import absolute_import, division, print_function
import sys
from Queue import Queue
from collections import defaultdict

class Trie(object):
    def __init__(self):
        self.children = defaultdict(Trie)
    
    def containsWord(self, word):
        if len(word) == 0:
            return True
        if word[0] in self.children:
            return self.children[word[0]].containsWord(word[1:])
        return False

def valid(x, y, grid):
    return 0 <= x < len(grid) and 0 <= y < len(grid[0])

visited = [[False] * 10 for _ in xrange(10)]

def build_trie(i, j, t, grid, depth, limit):
    # visited = [[False] * len(grid[0]) for _ in xrange(len(grid))]
    if not valid(i, j, grid) or visited[i][j] or depth >= limit:
        return
    visited[i][j] = True

    next_t = t.children[grid[i][j]]
    for next_x, next_y in [(i - 1, j), (i, j - 1), (i + 1, j), (i, j + 1)]:
        build_trie(next_x, next_y, next_t, grid, depth + 1, limit)
    visited[i][j] = False

def main():
    h, w = (int(x) for x in sys.stdin.readline().split())
    grid = [[x for x in sys.stdin.readline().strip()] for _ in xrange(h)]
    n = int(sys.stdin.readline())

    master_trie = Trie()
    #amar_edit, new input format, l = 10
    l = 10
    for i in xrange(h):
        for j in xrange(w):
            build_trie(i, j, master_trie, grid, 0, l)
    
    count = 0
    for _ in xrange(n):
        word = sys.stdin.readline().strip()
        if master_trie.containsWord(word):
            count += 1
    print(count)

    
        

if __name__ == '__main__':
    main()
