#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <memory>
#include <cstring>

using namespace std;

struct trie {
    vector<trie> children;
    bool visited; // FIXME: should not be needed
    
    bool find(const string& s, int i) {
        if (i >= s.size() && visited) return true;
        if (children.empty()) return false;
        return children[s[i]-'A'].find(s, i+1);
    }

    bool find(const string& s) {
        return find(s, 0);
    }
};

constexpr int MAXH = 10;
constexpr int MAXD = 10;

int h, w, n;
string M[MAXH], word;
bool V[MAXH][MAXH];
trie t;

void build_trie(int i, int j, int d, trie& u) {
    if (d >= MAXD) return;
    if (V[i][j]) return;
    V[i][j] = true;
    if (u.children.empty()) u.children = vector<trie>(26);
    u.visited = true; // FIXME: but why?

    for (int di = -1; di < 2; di++) {
        for (int dj = -1; dj < 2; dj++) {
            int i2 = i+di;
            int j2 = j+dj;
            if (abs(di) != abs(dj) && i2 >= 0 && i2 < h && j2 >= 0 && j2 < w) {
                build_trie(i2, j2, d+1, u.children[M[i2][j2] - 'A']);
            }
        }
    }
    V[i][j] = false;
}


int main() {
    ios::sync_with_stdio(false);
    cin >> h >> w;

    for (int i = 0; i < h; i++)
        cin >> M[i];

    t.children = vector<trie>(26);
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            build_trie(i, j, 0, t.children[M[i][j]-'A']);
    
    int count = 0;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> word;
        if (t.find(word)) count++;
    }

    cout << count << endl;
}
